
#prepare icon base offset
scoreboard players set #icon_spacing rpl 20
scoreboard players operation #icon_spacing rpl *= #in_range rpl
scoreboard players add #in_range rpl 1

#global rotation to target player
execute facing entity @s feet run rotate 298a7df5-298a-7df5-298a-7df5298a7df5 ~ ~
data modify storage rpl:data Rotation set from entity 298a7df5-298a-7df5-298a-7df5298a7df5 Rotation
execute store result score #target_rotation rpl run data get storage rpl:data Rotation[0] 100
execute store result score #target_vert_rotation rpl run data get storage rpl:data Rotation[1] 1

##VERTICAL ANGLE
scoreboard players operation #target_vert_rotation rpl -= #current_vert_rotation rpl
execute store result score $vertical rpl if score #target_vert_rotation rpl matches ..-30
execute if score #target_vert_rotation rpl matches 30.. run scoreboard players set $vertical rpl 2

##HORIZONTAL ANGLE
#negative angle = cw, positive angle = ccw.
execute store result score $angle rpl run scoreboard players operation #target_rotation rpl -= #current_rotation rpl
#normalize to -180, 180 range
execute if score $angle rpl matches 18001.. run scoreboard players remove $angle rpl 36000
execute if score $angle rpl matches ..-18001 run scoreboard players add $angle rpl 36000
#map (-45,45) degrees to (-186,-7)  icon axis
scoreboard players set #icon_position rpl 19889
scoreboard players operation #icon_position rpl *= $angle rpl
scoreboard players remove #icon_position rpl 96500000
scoreboard players operation #icon_position rpl /= #1000000 rpl
#limit icons to within bar
execute if score #icon_position rpl matches ..-187 run scoreboard players set #icon_position rpl -186
execute if score #icon_position rpl matches -6.. run scoreboard players set #icon_position rpl -7
#apply icon offset
scoreboard players operation #icon_position rpl -= #icon_spacing rpl

#color and distance
scoreboard players operation #color rpl = @s rpl
execute unless score #color rpl matches 100.. run scoreboard players add #color rpl 100
execute if entity @s[distance=..500] run scoreboard players set #distance_level rpl 9
execute if entity @s[distance=..450] run scoreboard players set #distance_level rpl 8
execute if entity @s[distance=..400] run scoreboard players set #distance_level rpl 7
execute if entity @s[distance=..350] run scoreboard players set #distance_level rpl 6
execute if entity @s[distance=..300] run scoreboard players set #distance_level rpl 5
execute if entity @s[distance=..250] run scoreboard players set #distance_level rpl 4
execute if entity @s[distance=..200] run scoreboard players set #distance_level rpl 3
execute if entity @s[distance=..150] run scoreboard players set #distance_level rpl 2
execute if entity @s[distance=..100] run scoreboard players set #distance_level rpl 1

execute if score #in_range rpl matches 1 run return run function rpl:locate/string_builder/icon_1
execute if score #in_range rpl matches 2 run return run function rpl:locate/string_builder/icon_2
execute if score #in_range rpl matches 3 run return run function rpl:locate/string_builder/icon_3
execute if score #in_range rpl matches 4 run return run function rpl:locate/string_builder/icon_4
execute if score #in_range rpl matches 5 run return run function rpl:locate/string_builder/icon_5
execute if score #in_range rpl matches 6 run return run function rpl:locate/string_builder/icon_6
execute if score #in_range rpl matches 7 run return run function rpl:locate/string_builder/icon_7
execute if score #in_range rpl matches 8 run return run function rpl:locate/string_builder/icon_8
execute if score #in_range rpl matches 9 run return run function rpl:locate/string_builder/icon_9
execute if score #in_range rpl matches 10 run return run function rpl:locate/string_builder/icon_10
